/* Patch generation test suite 
 *
 * Test for changing the element type of a list: version 2
 *
 * Version 0 element type:  struct { int x; }
 * Version 1 element type:  struct { int x; int y;}
 * Version 2 element type:  struct { float d; }
 */

#pragma __DSU_malloc("malloc");

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>


extern void __DSU_update();

struct T {
  float d;
};

struct Tlist {
  struct T item;
  struct Tlist* next;
};

struct Tlist* consT(struct T* pt, struct Tlist* pl)
{
  struct Tlist* l = malloc(sizeof(struct Tlist));
  l->next = pl;
  l->item = *pt;

  return l;
}

void iterT(void(*f)(struct T*), struct Tlist* pl)
{
  while(pl)
    {
      f(&pl->item);
      pl = pl->next;
    }
}

void printT(struct T* pt) {
   printf("t.d=%f\n",pt->d);
}

void printTlist(struct Tlist* pl)
{
  iterT(printT,pl);
}


int main()
{
  struct Tlist* pl = 0;
  struct T t;
  int i;
  char buf[100]; 

  for(i=0; i<10; i++) {
    t.d = i;
    pl = consT(&t,pl);
  }
   
  printTlist(pl);
   
  //read(stdin, buf, 10);
  getchar();

  printf("*** Start update\n\n\n");
  __DSU_update();
  printf("*** end update \n\n\n");

  printTlist(pl);
  printf("*** end print \n\n\n");
  return 0;
}
