/*
  We have a big problem.
 
- candidate update points are eliminated based on the mu of the
function they're in. The effects are not taken into account. This is
donwright unsafe ! See the example below, where the body of foo will
contain a __DSU_update(), although there's a con coming right after
it. Another way of pointing the problem out is running with
--updatepoints=full, and in that case the candidate update points
in main, before the while loop will NOT be removed !


*/

struct str_locate_result {
   int found ;
   unsigned int index ;
 
};

void foo()
{
}
void (*pf)() = &foo;

int main()
{
  struct str_locate_result screwy ;
  screwy.found = 21212;
  screwy.index = 31337;
  while (1){
    sleep(1);
    (*pf)();
    printf("screwy.index = %d\n", 
           screwy.index);
  }
  return 0;
}
