/* L on a function is the set of types invalidated by suspect
   pointers that are live in the environments of callers to the
   function (not including parameters on the function).

   G is the set of suspect types in the function's local environment
   (including the parameters and locals) and the global
   environment. */

struct T {
  int x;
  int y;
};

struct S {
  int z;
};

/* extern int __DSU_update() ; */
extern void dummy(int *z);

/* L == { S,T }, G == { S,T } */
void baz(int * /* {S,T} */ z) {
  *z = 1;
  dummy(z);
  /* no update here */
}

/* L == { }, G == { } */
void callbaz() {
  struct T t = {2,3};
  baz(&t.x);
  /* update here ok */
}

/* L == {}, G == { S,T } */
void bar(int */* {T} */ x) {
  struct S s = {1};
  int */* {S} */ z;
  z = &(s.z); /* makes z, above, suspect */
  *x = 1;
  baz(z); /* makes argument to baz suspect */
  /* no update here */
}

/* L == {}, G == {} */
void main() {
  struct T t = {1,2};
  bar(&(t.x)); /* makes T suspect on bar's argument */
  /* an update here will be OK */
  return;
}
