#ifndef DSU_DEBUG_H

#include "dsu_config.h"

#if DSU_ENABLE_DEBUG == 1
#define DSU_DEBUG(...) do { \
                                  if (__DSU_debug_file) \
                                  { \
 				    fprintf(__DSU_debug_file,"DSU DEBUG: ");\
                                    fprintf(__DSU_debug_file,__VA_ARGS__); \
                                    fflush(__DSU_debug_file); \
                                  } \
                                } \
                            while(0);
#else
#define DSU_DEBUG(...)
#endif

#if DSU_ENABLE_ERROR == 1
#define DSU_ERROR(...) do { \
                                  if (__DSU_debug_file) \
                                  { \
 				    fprintf(__DSU_debug_file,"DSU ERROR: ");\
                                    fprintf(__DSU_debug_file,__VA_ARGS__); \
                                    fflush(__DSU_debug_file); \
                                  } \
                                } \
                            while(0);
#else
#define DSU_ERROR(...)
#endif

#if DSU_ENABLE_FDEBUG == 1
#define DSU_FDEBUG(...) do { \
                                  if (__DSU_debug_file) \
                                  { \
 				    fprintf(__DSU_debug_file,"DSU FDEBUG: ");\
                                    fprintf(__DSU_debug_file,__VA_ARGS__); \
                                    fflush(__DSU_debug_file); \
                                  } \
                                } \
                            while(0);
#else
#define DSU_FDEBUG(...)
#endif

extern FILE *__DSU_debug_file;

#endif  //DSU_DEBUG_H
