/* Map implementation. Stores (char * key, void * value) pairs  */
#include <stdlib.h>
#include <search.h>


int mCompar(const void * v1, const void * v2)
{
  ENTRY * e1, * e2;
  e1 = (ENTRY *)v1;
  e2 = (ENTRY *)v2;

  //printf("****** '%s' '%s'\n", e1->key, e2->key);
  return strcmp(e1->key, e2->key);
}

void mFreeNode(void * nodep)
{
}

void * mCreateMap() 
{ 
  struct tree_root * tr_handle = calloc(1, sizeof(struct tree_root));
  
  return tr_handle;
}

void   mAdd(void * mapp, const char * key, void * value)
{ 
  ENTRY * e = malloc(sizeof(ENTRY));

  if (e == NULL)
    return;

  e->key = (char *)key;
  e->data = value;

  tsearch(e, &(((struct tree_root *)mapp)->rootp), mCompar);
}

void * mFind(void * mapp, const char * key)
{ 
  ENTRY e, * ret;
  e.key = (char *)key;

  ret = tfind(&e, &(((struct tree_root *)mapp)->rootp), mCompar);

  if (ret == NULL)
    return NULL;
  else
    return ret->data;
}

void   mRemove(void * mapp, const char * key)
{
  ENTRY e;
  e.key = (char *)key;

  tdelete(&e, &(((struct tree_root *)mapp)->rootp), mCompar);
}

void   mDeleteMap(void * mapp)
{
  tdestroy(((struct tree_root *)mapp)->rootp, mFreeNode);

  free(mapp);
}
